//
//  AbstractNetworkOperation.h
//  iSub
//
//  Created by Aaron Brethorst on 5/12/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

@interface AbstractNetworkOperation : NSOperation
{
    NSURL * _url;
	NSURLRequest *_request;
	NSURLCredential *_credential;
    NSURLConnection * _connection;
    NSInteger _statusCode;
    NSError * _error;
    
    BOOL _isExecuting;
    BOOL _isFinished;
}
@property (readonly, copy) NSURL * url;
@property (readonly, copy) NSURLRequest *request;
@property (copy) NSURLCredential *credential;
@property (readonly) NSInteger statusCode;
@property (readonly, retain) NSError * error;

@property (readonly) BOOL isExecuting;
@property (readonly) BOOL isFinished;

- (id)initWithUrl:(NSURL *)url;
- (id)initWithRequest:(NSURLRequest*)request;

//NSURLConnection delegate methods (for subclasses to implement)
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response;
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data;
- (void)connectionDidFinishLoading:(NSURLConnection *)connection;
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error;
@end
