//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

@class OAConsumer, OAToken;

extern NSString * const U1AccountManagerDidSignOut;


@interface U1AccountManager : NSObject

+ (U1AccountManager*)sharedAccountManager;

- (OAConsumer*)oauthConsumer;
- (OAToken*)oauthToken;
- (BOOL)hasCredentials;
- (void)storeConsumerKey:(NSString*)consumerKey consumerSecret:(NSString*)consumerSecret token:(NSString*)token tokenSecret:(NSString*)tokenSecret;
- (BOOL)isVerified;
- (void)setVerified:(BOOL)verified;
- (void)removeCredentials;

@end
