//
//  Copyright 2013 Canonical Ltd.
//
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>
#import <AssetsLibrary/AssetsLibrary.h>

#import "U1Asset.h"
#import "U1DataRepository.h"

@interface U1AssetManager : NSObject

@property (retain) ALAssetsLibrary *assetsLibrary;
@property (retain) U1DataRepository *dataRepository;

+ (U1AssetManager *)sharedAssetManager;

- (void)updatePhotoAssetsWithAsyncBlock:(void(^)(U1Asset *u1asset, BOOL isNew))assetBlock groupCompletionBlock:(void(^)(BOOL success))completionBlock;
- (U1Asset *)createU1AssetWithAsset:(ALAsset *)asset group:(ALAssetsGroup *)group URLString:(NSString *)urlString fileName:(NSString *)filename context:(NSManagedObjectContext*)context;
- (void)findOrCreateMatchingFileNodeForU1Asset:(U1Asset *)u1asset inFolderNode:(U1FolderNode *)folderNode context:(NSManagedObjectContext*)context;
@end
