//
//  Copyright 2013 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>
#import <AssetsLibrary/AssetsLibrary.h>

#import "U1AutoUploadOperation.h"

@class U1Asset;
@class U1DataRepository;
@class U1FileNode;
@class U1Volume;


@interface U1AutoUploadsManager : NSObject
@property (retain) U1DataRepository *dataRepository;
@property (retain) U1FolderNode *remoteUploadFolder;
@property (retain) ALAssetsLibrary *assetsLibrary;
+ (U1AutoUploadsManager *)sharedAutoUploadsManager;
- (int)numberOfAssets;
- (void)checkForNewAssets;
- (void)thumbnailForNode:(U1FileNode *)fileNode completionBlock:(void(^)(CGImageRef thumbnail))completionBlock;
- (U1AutoUploadOperation*)autoUploadOperationForAsset:(U1Asset *)assetToUpload andRepresentation:(ALAssetRepresentation *)representation inContext:(NSManagedObjectContext *)context;
- (int)pendingCount;
@end
