//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1ByteSizeValueTransformer.h"


@implementation U1ByteSizeValueTransformer

static NSString *suffixes[] = {@"B", @"KB", @"MB", @"GB", @"TB"};

+ (Class)transformedValueClass { return [NSString class]; }

+ (BOOL)allowsReverseTransformation { return NO; }

- (id)transformedValue:(id)value;
{
	if (![value isKindOfClass:[NSNumber class]])
		return nil;
	
	double size = [value doubleValue];
	NSUInteger suffixIndex = 0;
	while (size > 1024.f && ++suffixIndex < sizeof(suffixes))
	{
		size /= 1024.f;
	}

    return [NSString stringWithFormat:@"%.1f %@", size, suffixes[suffixIndex]];
}

@end
