//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

@class NSManagedObjectContext;
@class U1Node, U1FileNode, U1FolderNode;


@interface U1DataRepository : NSObject

@property (nonatomic, retain) NSManagedObjectModel *model;
@property (nonatomic, retain) NSManagedObjectContext *mainContext;
@property (nonatomic, retain) NSPersistentStoreCoordinator *storeCoordinator;

+ (U1DataRepository*)sharedDataRepository;
+ (NSURL*)databaseURLInDirectory:(NSUInteger)directory;
- (id)initWithStoreURL:(NSURL*)storeURL;
- (BOOL)save:(NSError**)error;
- (BOOL)reset:(NSError**)error;


- (U1Node*)nodeWithResourcePath:(NSString*)resourcePath;

- (NSArray*)resultsForEntityClass:(Class)entityClass matchingPredicate:(NSPredicate*)predicate withSortDescriptors:(NSArray*)sortDescriptors error:(NSError**)error;

- (NSArray*)resultsForEntityClass:(Class)class inContext:(NSManagedObjectContext*)context withPredicate:(NSPredicate*)predicate sortDescriptors:(NSArray*)sortDescriptors error:(NSError**)error;

- (void)dispatchBlockWithMainContext:(void(^)(NSManagedObjectContext *context))block;

- (void)dispatchBlockWithManagedObjectContext:(void(^)(NSManagedObjectContext *context))block;

- (void)dispatchAsyncBlockWithManagedObjectContext:(void(^)(NSManagedObjectContext *context))block;

@end
