//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>

@class U1FilesClient, U1FileNode;


@interface U1FileDetailsViewController : UIViewController <UIActionSheetDelegate, UITextFieldDelegate, UITableViewDataSource, UITableViewDelegate>

@property (nonatomic, retain, readonly) IBOutlet UIView *loadingContainerView;
@property (nonatomic, retain, readonly) IBOutlet UIView *fileAncillaryDetailsView;
@property (nonatomic, retain, readonly) IBOutlet UIImageView *iconImageView;
@property (nonatomic, retain, readonly) IBOutlet UILabel *nameLabel;
@property (nonatomic, retain, readonly) IBOutlet UIActivityIndicatorView *loadingActivityView;
@property (nonatomic, retain, readonly) IBOutlet UILabel *sizeLabel;
@property (nonatomic, retain, readonly) IBOutlet UILabel *createdLabel;
@property (nonatomic, retain, readonly) IBOutlet UILabel *modifiedLabel;
@property (nonatomic, retain, readonly) IBOutlet UIToolbar *toolbar;
@property (nonatomic, retain, readonly) IBOutlet UITextView *publicURLLabel;
@property (nonatomic, retain, readonly) IBOutlet UITextField *renameTextField;
@property (nonatomic, retain, readonly) IBOutletCollection(UITableViewCell) NSArray *sectionOneCells;
@property (nonatomic, retain, readonly) IBOutletCollection(UITableViewCell) NSArray *sectionTwoCells;
@property (nonatomic, retain, readonly) IBOutlet UITableView *actionsTableView;
@property (nonatomic, retain, readonly) IBOutlet UISwitch *publishSwitch;
@property (nonatomic, retain, readonly) IBOutlet UILabel *publishStatusLabel;

@property (readonly, retain) U1FileNode *node;
@property (retain) U1FilesClient *filesClient;

- (id)initWithNode:(U1FileNode*)node;

@end
