//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1FolderItemCell.h"

#import "U1LocalFileInfo.h"
#import "U1ViewNibLoader.h"


@interface U1FolderItemCell ()
+ (UINib*)cellNib;
@end


@implementation U1FolderItemCell

@synthesize iconImageView, nameLabel, detailLabel, uploadIndicator, uploadProgressView;
@synthesize fileInfo;

+ (U1FolderItemCell*)cellForTableView:(UITableView*)tableView;
{
	U1FolderItemCell *cell = (id)[tableView dequeueReusableCellWithIdentifier:NSStringFromClass(self)];
	if (!cell)
	{
		cell = [U1ViewNibLoader viewFromUINib:[U1FolderItemCell cellNib]];
	}
	return cell;
}

+ (UINib*)cellNib;
{
	static UINib *cellNib;
	static dispatch_once_t onceToken;
	dispatch_once(&onceToken, ^{
		cellNib = [[UINib nibWithNibName:NSStringFromClass(self) bundle:nil] retain];
	});
	return cellNib;
}

- (void)dealloc
{
	[iconImageView release];
	[nameLabel release];
	[detailLabel release];
	[uploadIndicator release];
	[uploadProgressView release];
	self.fileInfo = nil;
    [super dealloc];
}

@end
