//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>

#import "PullRefreshTableViewController.h"

@class U1FilesClient, U1Node;

@protocol U1FolderViewControllerDelegate;


@interface U1FolderViewController : PullRefreshTableViewController

@property (nonatomic, retain, readonly) IBOutlet UITableViewCell *loadingCell;
@property (assign) id<U1FolderViewControllerDelegate> delegate;
@property (retain) U1FilesClient *filesClient;

- (id)initWithNodeResourcePath:(NSString*)resourcePath;

@end


@protocol U1FolderViewControllerDelegate <NSObject>
@required
- (void)folderController:(U1FolderViewController*)folderController didSelectNode:(U1Node*)node;
@end
