//
//  Copyright 2012 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1HUDAlert.h"

#import <QuartzCore/QuartzCore.h>

@interface U1HUDAlert ()
{
	UIWindow *overlayWindow;
	UIWindow *lastKeyWindow;
}
@end


@implementation U1HUDAlert

- (id)init;
{
	self = [self initWithFrame:CGRectMake(60, 140, 200, 200)];
	[self.layer setCornerRadius:12.f];
	[self setBackgroundColor:[[UIColor blackColor] colorWithAlphaComponent:0.8f]];
	UIActivityIndicatorView *spinner = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
	spinner.center = CGPointMake(CGRectGetMidX(self.bounds),
								 CGRectGetMidY(self.bounds));
	[self addSubview:spinner];
	[spinner startAnimating];
	[spinner setHidesWhenStopped:YES];
	return self;
}

- (void)show;
{
	CGRect frame = [[UIScreen mainScreen] applicationFrame];
	overlayWindow = [[UIWindow alloc] initWithFrame:frame];
	self.center = CGPointMake(CGRectGetMidX(overlayWindow.bounds),
							  CGRectGetMidY(overlayWindow.bounds));
	[overlayWindow addSubview:self];
	lastKeyWindow = [[UIApplication sharedApplication] keyWindow];
	[overlayWindow makeKeyAndVisible];
}

- (void)dismiss;
{
	[lastKeyWindow makeKeyWindow], lastKeyWindow = nil;
	[overlayWindow removeFromSuperview];
	[overlayWindow release], overlayWindow = nil;
}

@end
