//
//  Copyright 2013 Canonical Ltd.
//
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

#import <AssetsLibrary/AssetsLibrary.h>

extern NSString * const U1ContentHashKey;
extern NSString * const U1MagicHashKey;

@interface U1Hasher : NSObject{
	dispatch_semaphore_t sync_semaphore;
}

@property (retain) ALAssetsLibrary *assetsLibrary;

- (NSDictionary *)synchronouslyGetHashesForAssetURL:(NSURL *)assetURL;

+ (NSData*)contentHashForAssetData:(NSData *)imageData length:(uint32_t)length;
+ (NSData*)magicHashForAssetData:(NSData *)imageData length:(uint32_t)length;


@end
