//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1JSONParsing.h"

#import <objc/runtime.h>


@implementation NSObject (U1JSONParsing)

+ (NSDictionary*)jsonPropertyKeyMapping;
{
	return nil;
}

- (id)parseFromJSONDictionary:(NSDictionary*)dictionary;
{
	NSDictionary *keyMapping = [[self class] jsonPropertyKeyMapping];
	
	Class class = [self class];
	unsigned int propertyCount = 0;
	objc_property_t *properties = class_copyPropertyList(class, &propertyCount);
	for (unsigned int p = 0; p < propertyCount; ++p)
	{
		objc_property_t property = properties[p];
		NSString *propertyName = [NSString stringWithCString:property_getName(property) encoding:NSUTF8StringEncoding];
		NSString *mappedName = [keyMapping objectForKey:propertyName];
		if (!mappedName)
			mappedName = propertyName;
		id value = [dictionary objectForKey:mappedName];
		if (!value)
			continue;
		[self setValue:value forKey:propertyName];
	}
	return self;
}

@end
