//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1SSOAccountResponse.h"


@implementation U1SSOAccountResponse

@synthesize displayName, openidIdentifier, preferredEmail, verifiedEmails, unverifiedEmails;

+ (NSDictionary*)jsonPropertyKeyMapping;
{
	return [NSDictionary dictionaryWithObjectsAndKeys:
			@"displayname", @"displayName",
			@"openid_identifier", @"openidIdentifier",
			@"preferred_email", @"preferredEmail",
			@"verified_emails", @"verifiedEmails",
			@"unverified_emails", @"unverifiedEmails",
			nil];
}

- (void)dealloc;
{
	[displayName release];
	[openidIdentifier release];
	[preferredEmail release];
	[verifiedEmails release];
	[unverifiedEmails release];
	[super dealloc];
}

- (NSString *)description;
{
	return [NSString stringWithFormat:@"<%@: %p; %@>", [self class], self, [self dictionaryWithValuesForKeys:[NSArray arrayWithObjects:@"status", @"message", @"errors", @"displayName", @"openidIdentifier", @"preferredEmail", @"verifiedEmails", @"unverifiedEmails", nil]]];
}

@end
