//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1SSOAuthenticateResponse.h"


@implementation U1SSOAuthenticateResponse

@synthesize name, consumerKey, consumerSecret, token, tokenSecret;

+ (NSDictionary*)jsonPropertyKeyMapping;
{
	return [NSDictionary dictionaryWithObjectsAndKeys:
			@"consumer_key", @"consumerKey",
			@"consumer_secret", @"consumerSecret",
			@"token_secret", @"tokenSecret",
			nil];
}

- (void)dealloc;
{
	[name release];
	[consumerKey release];
	[consumerSecret release];
	[token release];
	[tokenSecret release];
	[super dealloc];
}

- (NSString *)description;
{
	return [NSString stringWithFormat:@"<%@: %p; %@>", [self class], self, [self dictionaryWithValuesForKeys:[NSArray arrayWithObjects:@"status", @"message", @"errors", @"name", @"consumerKey", @"consumerSecret", @"token", @"tokenSecret", nil]]];
}

@end
