//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1SSOCredentialsViewController.h"


@implementation U1SSOCredentialsViewController

@synthesize emailField;
@synthesize passwordField;
@synthesize patternView;
@synthesize spinner;
@synthesize loginButton;
@synthesize loginAction;

- (void)dealloc;
{
	[emailField release];
	[passwordField release];
	[loginAction release];
    [patternView release];
	[loginButton release];
	[spinner release];
    [super dealloc];
}

- (void)viewDidUnload;
{
	[self setEmailField:nil];
	[self setPasswordField:nil];
    [self setPatternView:nil];
	[self setLoginButton:nil];
	[self setSpinner:nil];
	[super viewDidUnload];
}

- (void)viewDidLoad;
{
	[super viewDidLoad];
	
//	UIImage *backgroundImage = [UIImage imageNamed:@"header_bg"];
//	UIColor *backgroundColor = [[[UIColor alloc] initWithPatternImage:backgroundImage] autorelease];
//	[self.patternView setBackgroundColor:backgroundColor];
//	[self.patternView setOpaque:NO];
	// The following should not be necessary but without it the pattern color is opaque...
	// http://stackoverflow.com/questions/3899398/uicolor-colorwithpatternimage-alpha-blending-problem-solution-ios-sdk-4-1/5348396#5348396
//	[self.patternView.layer setOpaque:NO];
}

- (IBAction)logIn:(id)sender;
{
	[self.emailField resignFirstResponder];
	[self.passwordField resignFirstResponder];
	if (self.loginAction)
	{
		NSString *username = [self.emailField text];
		NSString *password = [self.passwordField text];
		self.loginAction(username, password);
		[self.spinner startAnimating];
	}
}

- (void)reset;
{
	[self.spinner stopAnimating];
}

@end
