//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

@protocol U1SingleSignOnProviderDelegate;
@class U1SSOAuthenticateResponse, U1SSOAccountResponse, U1SSOCaptchaResponse, U1SSOResponse;


@interface U1SingleSignOnProvider : NSObject

@property (assign) id<U1SingleSignOnProviderDelegate> delegate;

- (id)initWithNetworkQueue:(NSOperationQueue*)networkQueue;

- (id)requestNewCaptchaWithCompletionHandlerOnMainQueue:(void(^)(U1SSOCaptchaResponse *response, NSError *error))handler;

- (id)registerAccountForEmail:(NSString*)email
				 withPassword:(NSString*)password
				  displayName:(NSString*)displayName
					captchaId:(NSString*)captchaId
			  captchaSolution:(NSString*)captchaSolution
			completionHandlerOnMainQueue:(void(^)(U1SSOResponse *response, NSError *error))handler;

- (id)authenticateAccountForEmail:(NSString*)email
					 withPassword:(NSString*)password
						 appToken:(NSString*)appToken
				completionHandlerOnMainQueue:(void(^)(U1SSOAuthenticateResponse *response, NSError *error))handler;

- (id)requestPasswordResetTokenForEmail:(NSString*)email withCompletionHandlerOnMainQueue:(void(^)(U1SSOResponse *response, NSError *error))handler;

- (id)setNewPassword:(NSString*)password forEmail:(NSString*)email withToken:(NSString*)token completionHandlerOnMainQueue:(void(^)(U1SSOResponse *response, NSError *error))handler;

- (id)requestAccountDetailsWithCompletionHandler:(void(^)(NSError *error))handler;

@end


@protocol U1SingleSignOnProviderDelegate <NSObject>

- (NSURLRequest*)ssoProvider:(U1SingleSignOnProvider*)ssoProvider signedRequestForOAuthProtectionSpace:(NSURLRequest*)request;

@end


