//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "U1ViewNibLoader.h"


@implementation U1ViewNibLoader

@synthesize view;

+ (id)viewFromNib:(NSString*)nibPath;
{
    U1ViewNibLoader *loader = [[[U1ViewNibLoader alloc] init] autorelease];
    [[NSBundle mainBundle] loadNibNamed:nibPath owner:loader options:nil];
    UIView *view = [[loader.view retain] autorelease];
    return view;
}

+ (id)viewFromUINib:(UINib*)nib;
{
    U1ViewNibLoader *loader = [[[U1ViewNibLoader alloc] init] autorelease];
    [nib instantiateWithOwner:loader options:nil];
    UIView *view = [[loader.view retain] autorelease];
    return view;
}

- (void)dealloc;
{
	[view release];
    [super dealloc];
}

@end