//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>

#import "PullRefreshTableViewController.h"

@class U1FilesClient;
@class U1Volume, U1Node;

@protocol U1VolumesViewControllerDelegate;


@interface U1VolumesViewController : PullRefreshTableViewController

@property (nonatomic, retain, readonly) IBOutlet UITableViewCell *loadingCell;

@property (assign) id<U1VolumesViewControllerDelegate> delegate;
@property (retain) U1FilesClient *filesClient;

@end


@protocol U1VolumesViewControllerDelegate <NSObject>
@required
- (void)volumesController:(U1VolumesViewController*)volumesController didSelectVolume:(U1Volume*)volume;
- (void)folderController:(id)folderController didSelectNode:(U1Node*)node;
@end
