//
//  Copyright 2013 Canonical Ltd.
//
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.


#import "CoreDataTestCase.h"

#import "U1DataRepository.h"

@implementation CoreDataTestCase

- (void)setUp{
	[super setUp];
    model = [[NSManagedObjectModel mergedModelFromBundles: nil] retain];
    coord = [[NSPersistentStoreCoordinator alloc] initWithManagedObjectModel: model];
    store = [coord addPersistentStoreWithType: NSInMemoryStoreType
                                configuration: nil
                                          URL: nil
                                      options: nil
                                        error: NULL];
    ctx = [[NSManagedObjectContext alloc] init];
    [ctx setPersistentStoreCoordinator: coord];
	
	repository = [U1DataRepository sharedDataRepository];
	saved_ctx = [repository.mainContext retain];
	repository.mainContext = ctx;
	saved_coord = [repository.storeCoordinator retain];
	repository.storeCoordinator = coord;
}

- (void)tearDown{
    [ctx release];
    ctx = nil;
    NSError *error = nil;
    STAssertTrue([coord removePersistentStore: store error: &error],
                 @"couldn't remove persistent store: %@", error);
    store = nil;
    [coord release];
    coord = nil;
    [model release];
    model = nil;
	
	repository.mainContext = saved_ctx;
	[saved_ctx release];
	repository.storeCoordinator = saved_coord;
	[saved_coord release];
	
	[super tearDown];
}

@end
